;******************************************************************************
;		ATV controller for Comtech modules
;		Modified for PIC16F628A 26 July 2004
;		Improved frequency incrementing, less severe 4-09-04 now 3V1
;******************************************************************************
 
	LIST    p=16F628A 	;PIC16F628A is the target processor, chage for PIC16F628
		
 	__config _CP_OFF & _INTRC_OSC_NOCLKOUT & _PWRTE_ON & _WDT_ON & _LVP_OFF & _MCLRE_OFF
 		
;******************************************************************************

		include p16f628A.inc	;Change for 16F628
		
;******************************************************************************

; 	STATUS Reg Bits

#define		carry	STATUS,C
#define		c	STATUS,C
#define		dc	STATUS,C
#define		z	STATUS,Z
#define		pd	STATUS,PD
#define		to	STATUS,TO
#define		rp0	STATUS,RP0
#define		rp1	STATUS,RP1
#define		irp	STATUS,IRP

; 	INTCON Reg Bits

#define		rbif	INTCON,RBIF
#define		intf	INTCON,INTF
#define		t0if	INTCON,T0IF
#define		rbie	INTCON,RBIE
#define		inte	INTCON,INTE
#define		t0ie	INTCON,T0IE
#define		eeie	INTCON,EEIE		
#define		gie	INTCON,GIE

; 	OPTION Reg Bits

#define		ps0	OPTION_REG,PS0
#define		ps1	OPTION_REG,PS1
#define		ps2	OPTION_REG,PS2
#define		psa	OPTION_REG,PSA
#define		t0se	OPTION_REG,T0SE
#define		t0cs	OPTION_REG,T0CS
#define		intedg	OPTION_REG,INTEDG
#define		not_rbpu	OPTION_REG,NOT_RBPU
#define		c2out	CMCON,C2OUT

;	EECON1 reg bits

#define		wr	EECON1,WR
#define		rd	EECON1,RD
#define		wren	EECON1,WREN


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Lcd_Data	equ	PORTB
Key_Port	equ	PORTB
 
;		Port A bit equates
#define 	Beep_Pin	PORTA,0		; Key confirmation beep pin
#define 	S_Pin		PORTA,1		; S meter input
#define		R_w		PORTA,1		; Dispay read/write
;#define 	Scl		PORTA,2		; I2C Scl pin
#define		PaPower		PORTA,3		; PaPower control for TX PA
;#define		TestPin		PORTA,3		;
#define 	ReDown		PORTA,5		; Rotary encoder down input
#define 	TxPower		PORTA,6		; Transmitter power enable
#define 	KeyEnable	PORTA,7		; Low when reading keys

;		Port B bit equates

#define		ReInt		PORTB,0		; Rotary encoder interupt (INT0)
#define 	ReUp		PORTB,0		; Rotary encoder up input
#define		Rs		PORTB,1		; Display register select
;#define 	RxSda		PORTB,1		; I2C RxSda pin
#define		CoRelay		PORTB,2		; Antenna change over relay
#define		Disp_En		PORTB,3		; lcd enable control line

#define		Scl			2
#define		RxSda			1
#define		TxSda			4

;******************************************************************************
;		Macros
;******************************************************************************

ClrScl	macro	
	bcf    	PORTA,Scl       	
	bsf	rp0
	bcf    	TRISA,Scl       	; Set port as output and low
	bcf	rp0
	endm

SetScl	macro	
	bsf	rp0
	bsf    	TRISA,Scl       	; Set port as input
	bcf	rp0
	endm

ClrRxSda	macro
	bcf    	PORTB,RxSda       	
	bsf	rp0
	bcf    	TRISB,RxSda       	; Set port as output and low
	bcf	rp0
	endm

SetRxSda	macro	
	bsf    	PORTB,RxSda       	; Set port as output and low
	endm
	
ClrTxSda	macro
	bcf    	PORTA,TxSda       	
	bsf	rp0
	bcf    	TRISA,TxSda       	; Set port as output and low
	bcf	rp0
	endm

SetTxSda	macro	
	bsf	rp0
	bsf    	TRISA,TxSda       	; Set port as input (pulled high by I2C pullup R)
	bcf	rp0
	endm

;******************************************************************************
;	Data memory locations
;******************************************************************************
	cblock	0x20	;define constants starting at 20 hex
;	First bytes loaded from Eeprom on reset
Flags1	
RxMemNum
TxMemNum
IfOfstLo
IfOfstHi

Flags2

Char                 
Temp                  
Temp_1  
Temp2               

Count
Bit_Count
SequenceCount

Beep_Duration
Display_Duration
Key_Duration
KeyMode

lsb
msb

Lsd
Msd

OolCount

Pass_Count	 	
S_Count

Counter_500uS
Counter_5ms
Counter_50mS
Counter_1s

Init_Disp_Delay

Text_pointer

Latest_Key
Last_Key

Spare_W
Spare_STATUS

KeyValue

Buffer_0	
Buffer_1	
Buffer_2	
Buffer_3	
Buffer_4	
Buffer_5	
Buffer_6	
Buffer_7	
Buffer_8	
Buffer_9	
Buffer_10	
Buffer_11	

ACC_a_0 		
ACC_a_1 		
ACC_b_0 		
ACC_b_1
ACC_b_2
ACC_c_0 		
ACC_c_1 		
ACC_c_2 		
ACC_d_0  	
ACC_d_1
ACC_d_2

R0		
R1		
R2
R3
		
Synth_LO
Synth_HI

ScanLoLimitLo
ScanLoLimitHi

ScanHiLimitLo
ScanHiLimitHi

RxFrqHi		
RxFrqLo

TxFrqHi		
TxFrqLo

RxMinLmtLo		
RxMinLmtHi		

RxMaxLmtLo		
RxMaxLmtHi		

TxMinLmtLo		
TxMinLmtHi		

TxMaxLmtLo		
TxMaxLmtHi		

I2cData

ReIncTimer
ReDecTimer
Save_Delay
Wait_Count
	endc
	
;******************************************************************************
;		Register Bit Equates
;******************************************************************************
;	Flags1 recalled at startup
#define		RxTxFlag		Flags1,0	; Indicates Rx or Tx control 
#define		TxOn			Flags1,1	; Set when in tx mode
#define		AutoNetEnable		Flags1,2	; Autonet turned on
#define		SystemFlag		Flags1,3	; Set when in Rx mode only	 
#define		ThirteenCmFlag		Flags1,4	; Set when in 13CM mode
#define		VFOLinkFlag		Flags1,5	; Set when VFOs are linked
#define		VFOScanFlag		Flags1,6	; Set when in VFO scan
;#define				Flags1,7	

#define		New_Key_Flag		Flags2,0	; A new keypress identified
#define		S_Flag			Flags2,1	; Indicates "S" meter in operation
#define		IfSetFlag		Flags2,2	; Indicates in IF set mode
#define		AutoNetOn		Flags2,3	; Indicates transmitter I2C OK
#define		InitRequestFlag		Flags2,4	; Set when system or band change made
#define		FrqScanFlag		Flags2,5	; Set when in scan mode	 	
#define		Beep_Flag		Flags2,6
#define		mult_carry		Flags2,7

;******************************************************************************
;		Constants
;******************************************************************************
Lcd_Port	equ     TRISB
					
Func_set        equ     b'00101000'
Display_off     equ     b'00001000'
Display_on      equ     b'00001100'     ;cursor off (bit 2)
Clr_display     equ     b'00000001'
Shift_Left	equ	b'00010000'
Entry_inc       equ     b'00000110'
Dd_ram_addr     equ     b'10000000'
Line_One	equ	b'10000000'
Line_Two	equ	b'11000000'

Lcd_init_delay  equ     .50

Portb_Out 	equ	b'00001111'  	;"and" with TRISB register
Portb_In	equ	b'11110000'	;"or" with TRISB register

VRCON_Clear	equ	b'10000000'	; Reset VRCON at lowest output

VersionNumber	equ	.31

RxI2cAddr		equ	b'11000010'	; Receiver I2C address
TxI2cAddr		equ	b'11000010'	; Transmiter I2C address
Synth_Control_1		equ	b'10001110'	; Synth control byte 1
Synth_Control_2		equ	b'00000000'	; Synth control byte 2
IFOffset		equ	(.479500/.125)	; IF frequency / channel step
Band1DefaultFreq	equ	.10280		; Default frequency for 23CM
Band2DefaultFreq	equ	.19200		; Default frequency for 13CM

FlagsAddr		equ	.0		; Stored flags
RxMemAddr		equ	.1		; Current Rx memory
TxMemAddr		equ	.2		; Current Tx memory
IfOstLoAddr		equ	.3		; IF offset low
IfOstHiAddr		equ	.4		; IF offset high
RxMemBaseAddr		equ	.5		; Start position in Eeprom of Rx memories
TxMemBaseAddr		equ	.66		; Start position in Eeprom of Tx memories
VersionNumberAddr	equ	.127		; Firmware version

MaxMem			equ	.6		; Maximum number of memories

Lock_Wait_Time		equ	.226		; Set for nominal 60ms delay

Timer500uSValue		equ	.5

Rx1MinLmt		equ	(.800000/.125)
Rx1MaxLmt		equ	(.1800000/.125)

Tx1MinLmt		equ	(.1240000/.125)
Tx1MaxLmt		equ	(.1320000/.125)

Rx2MinLmt		equ	(.2200000/.125)
Rx2MaxLmt		equ	(.2700000/.125)

Tx2MinLmt		equ	(.2310000/.125)
Tx2MaxLmt		equ	(.2450000/.125)

IfFreqMin		equ	(.474500/.125)	; Minimum allowable IF frequency
IfFreqMax		equ	(.484500/.125)	; Maximum allowable IF frequency

;******************************************************************************
;		Main code
;******************************************************************************

	org	0			; The start
	goto	Initialise
	
;******************************************************************************
	org	h'04'			; Interupt Vector
	bcf	gie			; Stop more interupts
	; Save disturbed registers
	movwf	Spare_W			; Save W register
	swapf	STATUS,w
	movwf	Spare_STATUS		; Save STATUS without affecting bits
	btfss	inte
	goto	Not_Int			; Not called by int
	btfss	intf
	goto	Not_Int			; Not called by int
	; INT detected, wait for 1ms - debounce period
	bcf	intf
	clrf	TMR1L
	movlw	.252
	movwf	TMR1H			; Load timer1
	bcf	PIR1,TMR1IF		; Clear timer 1 overflow flag
	bsf	T1CON,TMR1ON		; Start timer1
Timer1Loop
	btfss	PIR1,TMR1IF		; Check timer 1 overflow flag
	goto	Timer1Loop		; Loop if not 1ms
	bcf	T1CON,TMR1ON		; Stop timer1
	btfsc	ReDown
	goto	NotReUp
	call	ReDec			; Interupt generated by valid int
	goto	Not_Int
NotReUp
	btfsc	ReUp
	goto	Not_Int
	call	ReInc			; Interupt generated by valid int
Not_Int	
	; Reload saved registers
	swapf	Spare_STATUS,w		; Reload STATUS register
	movwf	STATUS
	swapf	Spare_W,f	
	swapf	Spare_W,w		; Reload W register
	bcf	intf
	retfie				; Return from interupt enabling gie
	;	
;******************************************************************************
;	Text to be output to LCD module
;******************************************************************************
TextTable				;begining of text tables							
	movwf   PCL          		;jump to Char pointed to 
 
Text_Welcome
	dt	"ATV Controller  ",0
	;dt	"Prprty of GXXXX ",0    ;Enter your callsign here and "rem" out the line above

Text_Welcome2	
	dt	"Version 3.1     ",0
	
Text_S
	dt	"S               ",0

Text_MHz
	dt	"MHz ",0

Text_SetIfOffset
	dt	"Set IF Frequency",0
	
TextVFOLinked	
	dt	"Linked VFOs     ",0
	
TextSetAutoNet
	dt	"Set AutoNet",0
	
TextSystemSet
	dt	"Set System",0
	
TextBandSet
	dt	"Set Band",0
	
TextRxOnly
	dt	"Receive Only",0
	
TextRxandTx
	dt	"Rx and Tx   ",0
	
Text13CM
	dt	"13CM",0

Text23CM
	dt	"23CM",0

TextOff
	dt	"Off",0
	
TextOn
	dt	"On ",0
		
TextTableEnd
	if HIGH TextTable != HIGH TextTableEnd 
	error "Text Table breaks page boundary"
	endif
	;
;******************************************************************************
;	cg ram table - data loaded into user ram in LCD module
;	at program startup for "S" meter bars
;******************************************************************************
cg_ram_table
	addwf   PCL,f          	;jump to Char pointed to in w reg
	retlw	b'10000000'	;cg ram chacter no.1
	retlw	b'10000000'
	retlw	b'10011111'
	retlw	b'10011111'
	retlw	b'10011111'
	retlw	b'10000000'
	retlw	b'10000000'
	retlw	b'10000000'
	retlw	0		;stop here!
cg_ram_tableEnd
	if HIGH cg_ram_table != HIGH cg_ram_tableEnd 
	error "cg_ram_table breaks page boundary"
	endif
	;
;******************************************************************************
;	Key routine jump table - indexed into table by KeyValue
;	and Menu_Level
;******************************************************************************
JumpTable
;	clrf	PCLATH
	addwf	PCL,f		; jump into table
	goto	SelectVFOKey	; KeyMode 0 Key0 - Switch between Rx and Tx VFO 
	goto	IncVFOKey	; KeyMode 0 Key1 - Increment curent VFO 
	goto	PttKey		; KeyMode 0 Key2 - TRansmit / receive change-over
	goto	ScanKey		; Keymode 0 Key3 - Set scan mode
	goto	MenuReset	; KeyMode 1 Key0 - Abort setup menu
	goto	AutoNetSet	; KeyMode 1 Key1 - Saves IF offset and enters AutoNet setup
	goto	MenuReset	; KeyMode 1 Key2 - Abort setup menu
	goto	MenuReset	; KeyMode 1 Key3 - Abort setup menu
	goto	MenuReset	; KeyMode 2 Key0 - Abort setup menu
	goto	SystemSet	; KeyMode 2 Key1 - Saves AutoNet setting and enters System setup
	goto	MenuReset	; KeyMode 2 Key2 - Abort setup menu
	goto	MenuReset	; KeyMode 2 Key3 - Abort setup menu
	goto	MenuReset	; KeyMode 3 Key0 - Abort setup menu
	goto	BandSet		; KeyMode 3 Key1 - Saves System setting and enters Band setup
	goto	MenuReset	; KeyMode 3 Key2 - Abort setup menu
	goto	MenuReset	; KeyMode 3 Key3 - Abort setup menu
	goto	MenuReset	; KeyMode 4 Key0 - Abort setup menu
	goto	VFOLinkSet	; KeyMode 4 Key1 - Saves Band setting and enters linked VFO setup
	goto	MenuReset	; KeyMode 4 Key2 - Abort setup menu
	goto	MenuReset	; KeyMode 4 Key3 - Abort setup menu
	goto	MenuReset	; KeyMode 5 Key0 - Abort setup menu
	goto	MenuSaveSet	; KeyMode 5 Key1 - Saves Linked VFO setting and exits setup
	goto	MenuReset	; KeyMode 5 Key2 - Abort setup menu
	goto	MenuReset	; KeyMode 5 Key3 - Abort setup menu
JumpTableEnd
	if HIGH JumpTable != HIGH JumpTableEnd 
	error "Jump Table breaks page boundary"
	endif
	;
;******************************************************************************
;	Write cg ram - routine to write data to user cg ram in LCD module
;******************************************************************************
write_cg_ram
	movlw	b'01000000'		; Write character no.0
	call	send_cmd
	movlw	00			; Address of first byte
write_cg_ram_loop
	movwf	Temp_1
	call	cg_ram_table
	andlw   0ffh            	; Check if at end of data (zero
	btfsc   STATUS ,Z       	;  returned at end, all other data must
	goto    write_cg_ram_end  	;  be >0)           
	call    send_char       	; Store cg data
	movf    Temp_1,w         	; Point to next data
	addlw   .1
	goto    write_cg_ram_loop
write_cg_ram_end
	return
	;	
;******************************************************************************
Welcome_Routine
	movlw	.2
	movwf	Init_Disp_Delay	; Initialise startup display delay
	movlw	Clr_display
	call	send_cmd
	movlw	.60
	movwf	Beep_Duration			; Set for long beep
	movlw   b'10000000'			; Sets ram address at 00h i.E. the start
	call    send_cmd
	movlw	Text_Welcome - TextTable	; Point to message
	call	LCD_Out
	movlw   Line_Two			; First digit line 2
	call    send_cmd
	movlw	Text_Welcome2 - TextTable	; Point to message
	call	LCD_Out
	return
	;
;******************************************************************************
;	Initialise - power_on reset (beginning of program).
;******************************************************************************
Initialise
	clrwdt
	movlw	b'00110101'
	movwf   PORTA           	; Set Port A pin levels
	movlw	b'11111011'	
	movwf	PORTB			; Set Port B pin levels
	bsf     rp0	   		; Select bank 1.
	movlw	b'00110111'		; Set tristate port A
	movwf	TRISA
	movlw	b'11110001'		; Set tristate port B
	movwf   TRISB        		;
	movlw	b'00000000'		; Set up OPTION reg for Pull ups on,
	movwf	OPTION_REG		;  INT on falling edge, TMR0 internal cloc pre-scaler /2
					; Set timer 0 for system clock
	movlw	b'00000000'		; Set up Timer1
	movwf	T1CON
	movlw	VRCON_Clear		; Set up voltage reference module
	movwf	VRCON
	bcf	t0cs			
	bcf	rp0		
	movlw	b'11000111'		; Set comparator module
	movwf	CMCON
	clrf	Flags2
	clrf	Beep_Duration
	clrf	Display_Duration
	clrf	KeyMode
	bsf     rp0	   		; Select bank 1.
	movlw	b'00000001'		; Set port b for lcd output (RB4-7),
	movwf   TRISB        		
	bcf	rp0	
	bsf	KeyEnable
	; Initialise timer values
	movlw	Timer500uSValue		; Initialise Timer 0 
	movwf	TMR0
	movlw	.10		
	movwf	Counter_5ms		; Initialise 5ms counter
	movlw	.10
	movwf	Counter_50mS		; Initialise 50mS counter (for "S" meter)
	movlw	.20			; Reload 1 sec counter
	movwf	Counter_1s
	; initialise display
	call	Lcd_init		; Initialise LCD display
	call 	write_cg_ram		; Write "S" bar to CG ram
	movlw	Display_on		; Turn display on
	call	send_cmd
	; Check for valid Eeprom contents
	bsf	rp0
	movlw	VersionNumberAddr
	movwf	EEADR
	bsf	rd
	movlw	VersionNumber
	subwf	EEDATA,w
	bcf	rp0
	btfss	z			
	call	EEPROMInit	
	btfss	PORTB,4			; Test VFO pin for manual initialisation
	call	EEPROMInit	
	; Recall current flags etc from Eeprom
	call	RecallSettings
	; Recall current frequency settings from Eeprom
	call	RecallFrequency
	; Load frequency limits dependent on band in use
	btfsc	ThirteenCmFlag
	goto	LoadBand2		; Load 13CM limits
	call	LoadBand1Limits
	goto	BandLimitsLoaded	
LoadBand2	
	call	LoadBand2Limits		; Load 23CM limits
BandLimitsLoaded
	SetScl
	SetRxSda
	bcf	intf
	bsf	inte
	call	RxSynthOut
	call	TxSynthOut
	call	Welcome_Routine
	bsf	gie			; Enable global interupt
	;
;*****************************************************************************
Main
	; Main routine loop
	btfsc	t0if
	call	Timer_Routine
	clrwdt				; Reset watchdog timer
	goto	Main
	;
;*****************************************************************************
;Pass_Count = 0 first time a key is pressed.
;
;On identifying a key press New_Key_Flag is set and Pass_Count given a
;value of 70ms i.e. (256-242)*5ms
;
;2nd time through routine Pass_Count is incremented i.e. decreased by 5ms.
;
;After 20ms i.e. 4 passes since key first pressed, the key id is stored in Last_Key
;this delay is to avoid key bounce. Pass_Count is set to 40ms and key_parse routes 
;program to apropriate routine.
;
;Every time KeyService is called while the same key is pressed, Pass_Count is given
;the value 40ms.
;
;When no key or a different key is pressed key_parse is still entered but the
;Pass_Count is decreased by 5ms.
;
KeyService
	movfw	Key_Port  
 	andlw  	b'11110000'	; Gate out key pins
	movwf  	Latest_Key   	; Store latest key press
 	movf   	Pass_Count,f
	skpnz
 	goto   	key_pressed?
	incf   	Pass_Count,f
 	skpnz
 	goto   	key_parse   	; Key timed out call for last time
	movlw  	.246          	; Check to see if pass count
	subwf  	Pass_Count,w 	; Is > or < or = to 50ms
	skpc  
 	goto   	KeyServiceEnd 	; Greater than 50ms
	skpz
	goto   	same_key?    	; Lower than 50ms
	movfw  	Latest_Key  		  
	movwf  	Last_Key  	; Update last key pressed with new key value
same_key?     
	movfw  	Latest_Key	; Check to see if key inputs
	subwf  	Last_Key,w	; Still the same
 	skpz
	goto   	key_parse 	; Different input
	movlw  	.248
	movwf  	Pass_Count 	; Set pass count to 40ms
key_parse  
	movf   	Last_Key,f
	skpnz
	goto   	Ks1
	clrf	KeyValue
	movlw	b'11010000' 	; MODE
	subwf	Last_Key,w
	skpnz
	goto	Ks2
	incf	KeyValue,f
	movlw 	b'11100000'	; VFO
	subwf	Last_Key,w
	skpnz
	goto	Ks2
	incf	KeyValue,f
	movlw 	b'10110000' 	; PTT
	subwf	Last_Key,w
	skpnz
	goto	Ks2
	incf	KeyValue,f
	movlw 	b'11000000' 	; Scan (mode and VFO pressed)
	subwf	Last_Key,w
	skpz
	goto	KeyServiceEnd
Ks2
	movlw	HIGH JumpTable
	movwf	PCLATH
	bcf	carry
	rlf	KeyMode,w		; *2 and leave in W
	movwf	Temp2
	rlf	Temp2,w			; *2 and leave in w
	addwf	KeyValue,w		; Add key mode offset and leave in W
	call	JumpTable
KeyServiceEnd
	return
key_pressed?
	movf	Latest_Key,f 		; If no key pressed abort
	skpnz
	goto	KeyServiceEnd
	bsf 	New_Key_Flag		; New key press identified
	clrf	Key_Duration
	movlw	.242			; Load pass count 
	movwf	Pass_Count		;  with a 70ms delay
	goto 	KeyServiceEnd
Ks1
	bcf	New_Key_Flag
	goto	KeyServiceEnd
;*****************************************************************************
SelectVFOKey
	call	ClearScan
	incf	Key_Duration,f
	movfw	Key_Duration
	sublw	.255
	btfsc	z
	goto	SetSMeter
	;
	btfss	New_Key_Flag
	goto	SelectVFOKeyEnd		; Not a new key press
	bcf	New_Key_Flag
	btfsc	SystemFlag		; Check for recieve only mode
	goto	SelectVFOKeyEnd		; Abort as Tx VFO not available in Rx only mode
	btfsc	S_Flag
	goto	SetSMeterOff		; Turn meter off if on
	btfss	RxTxFlag		; Already in Rx mode?
	goto	SelectVFOKey2		; No
	bcf	RxTxFlag		; Set to transmit mode
SelectVFOKey1
	call	SaveSettings
	call	RxRoutine
	call	TxRoutine
	call	Beep_Set
SelectVFOKeyEnd
	return
	;	
SelectVFOKey2
	bsf	RxTxFlag		; Set to receive mode
	goto	SelectVFOKey1
	;	
SetSMeter
	call	SetupSMeter
	call	Beep_Set
	goto	SelectVFOKeyEnd
	;
SetSMeterOff
	bcf	S_Flag
	call	TxRoutine
	call	RxRoutine
	call	Beep_Set
	goto	SelectVFOKeyEnd

;*****************************************************************************
IncVFOKey
	call	ClearScan
	incf	Key_Duration,f
	movfw	Key_Duration
	sublw	.255
	btfsc	z
	goto	ModeSetCalled
	;
	btfss	New_Key_Flag
	goto	IncVFOKeyEnd		; Not a new key press
	bcf	New_Key_Flag
	movf	Save_Delay,f		; Test for saved frequency
	btfss	z
	call	SaveFrequency		; Save frequency if it hasn't been
	btfsc	RxTxFlag		; Already in Rx mode?
	goto	IncRxVFO		; No
	incf	TxMemNum,f		; Yes, so increment memory number
	movlw	MaxMem + 1
	subwf	TxMemNum,w		; Greater than MaxMem?
	btfsc	carry
	clrf	TxMemNum		; Yes, so reset
	movfw	TxMemNum		; If link flag is set
	btfsc	VFOLinkFlag		;   Rx VFO number= Tx VFO number
	movwf	RxMemNum
IncVFOKey1
	call	RecallFrequency
	call	SaveSettings
	call	RxRoutine
	call	TxRoutine
	call	Beep_Set
IncVFOKeyEnd
	return
	;
IncRxVFO
	call	IncMemory
	goto	IncVFOKey1
	;
IncMemory
	incf	RxMemNum,f		; Yes, so increment memory number
	movlw	MaxMem + 1
	subwf	RxMemNum,w		; Greater than MaxMem?
	btfsc	carry
	clrf	RxMemNum		; Yes, so reset
	movfw	RxMemNum		; If link flag is set
	btfsc	VFOLinkFlag		;  Tx VFO number = Rx VFO number
	movwf	TxMemNum
	return
	;
ModeSetCalled
	bcf	S_Flag
	clrf	Key_Duration
	bsf	RxTxFlag		; Force in to receive mode
	bsf	IfSetFlag		; Indicate in IF set mode
	call	IfSetDisplay
	movlw	.1
	movwf	KeyMode
	call	Beep_Set
	goto	IncVFOKeyEnd
	;
ScanKey
	incf	Key_Duration,f
	movfw	Key_Duration
	sublw	.255
	btfsc	z
	goto	SetVFOScan
	;
	btfss	New_Key_Flag
	goto	ScanKeyEnd		; Not a new key press
	bcf	New_Key_Flag
	btfsc	TxOn			; Check for transmit on
	goto	ScanKeyEnd		; Abort as Tx VFO not available in Rx only mode
	bsf	RxTxFlag		; Set to Rx entry mode
	call	SaveFrequency		; Save frequency if it hasn't been
	;	Recall and save scan limits from VFOs max and max -1
	movlw	MaxMem
	movwf	RxMemNum		
	call	RecallFrequency		; Recall lower limit
	movfw	RxFrqLo
	movwf	ScanHiLimitLo		; Save in limit registers
	movfw	RxFrqHi
	movwf	ScanHiLimitHi
	movlw	MaxMem - 1
	movwf	RxMemNum		
	call	RecallFrequency		; Recall lower limit
	movfw	RxFrqLo
	movwf	ScanLoLimitLo		; Save in limit registers
	movfw	RxFrqHi
	movwf	ScanLoLimitHi
	clrf	RxMemNum		; Use memory 0
	call	RxRoutine
	call	TxRoutine
	bsf	FrqScanFlag
	call	Beep_Set
ScanKeyEnd
	return
SetVFOScan
	btfsc	TxOn			; Check for transmit on
	goto	ScanKeyEnd		; Abort as Tx VFO not available in Rx only mode
	bcf	FrqScanFlag
	bsf	VFOScanFlag
	call	Beep_Set
	goto	ScanKeyEnd
	;	
ClearScan
	btfss	New_Key_Flag
	goto	ClearScanEnd
	btfsc	FrqScanFlag
	goto	ClearScanFlags
	btfss	VFOScanFlag
	goto	ClearScanEnd
ClearScanFlags
	bcf	New_Key_Flag
	bcf	FrqScanFlag		; If scan set then clear
	bcf	VFOScanFlag		;  flags
	call	Beep_Set
ClearScanEnd
	return
	;
ReClearScan
	btfss	FrqScanFlag
	goto	ReClearScanEnd
	bcf	FrqScanFlag		; If scan set then clear
	call	Beep_Set
ReClearScanEnd
	return
	;
ScanInc					; Entry point for scan
	movlw	.2			; scan spacing 250KHz
	addwf	RxFrqLo,f
	btfsc	carry
	incf	RxFrqHi,f
	movfw	ScanHiLimitLo
	subwf	RxFrqLo,w
	movfw	ScanHiLimitHi
	btfss	carry
	addlw	.1
	subwf	RxFrqHi,w
	btfss	carry
	goto	ScanIncOK
	movfw	ScanLoLimitLo
	movwf	RxFrqLo
	movfw	ScanLoLimitHi
	movwf	RxFrqHi
ScanIncOK
	call	RxRoutine		; Forces recall of memory to synth etc
ScanIncEnd
	return
	;
;*****************************************************************************
;	VFOScan - Called from timer routine when VFOScanFlag is set 
;******************************************************************************
VFOScan
	call	IncMemory
	call	RecallFrequency		; Recall frequency
	call	RxRoutine
	call	TxRoutine
	return
	;
;*****************************************************************************
;	LoadBand1Limits - loads band limits into ram 
;******************************************************************************
LoadBand1Limits
	movlw	LOW Rx1MinLmt		; Load Rx minimum frequency
	movwf	RxMinLmtLo
	movlw	HIGH Rx1MinLmt
	movwf	RxMinLmtHi
	;
	movlw	LOW Rx1MaxLmt		; Load Rx maximum frequency
	movwf	RxMaxLmtLo	
	movlw	HIGH Rx1MaxLmt	
	movwf	RxMaxLmtHi
	;	
	movlw	LOW Tx1MinLmt		; Load Tx minimum frequency
	movwf	TxMinLmtLo			
	movlw	HIGH Tx1MinLmt
	movwf	TxMinLmtHi
	;			
	movlw	LOW Tx1MaxLmt		; Load Tx maximum frequency
	movwf	TxMaxLmtLo			
	movlw	HIGH Tx1MaxLmt
	movwf	TxMaxLmtHi
	return
	;
;*****************************************************************************
;	LoadBand2Limits - loads band limits into ram 
;******************************************************************************
LoadBand2Limits
	movlw	LOW Rx2MinLmt		; Load Rx minimum frequency
	movwf	RxMinLmtLo
	movlw	HIGH Rx2MinLmt
	movwf	RxMinLmtHi
	;
	movlw	LOW Rx2MaxLmt		; Load Rx maximum frequency
	movwf	RxMaxLmtLo	
	movlw	HIGH Rx2MaxLmt	
	movwf	RxMaxLmtHi
	;	
	movlw	LOW Tx2MinLmt		; Load Tx minimum frequency
	movwf	TxMinLmtLo			
	movlw	HIGH Tx2MinLmt
	movwf	TxMinLmtHi
	;			
	movlw	LOW Tx2MaxLmt		; Load Tx maximum frequency
	movwf	TxMaxLmtLo			
	movlw	HIGH Tx2MaxLmt
	movwf	TxMaxLmtHi
	return
	;
;*****************************************************************************
;	SetupSMeter - Sets up S meter 
;******************************************************************************
SetupSMeter
	bsf	RxTxFlag		; Set to receive mode
	bsf	S_Flag
	call	RxDisplayRoutine	; Re display Rx frequency
	movlw	Line_Two
	call	send_cmd
	movlw	Text_S - TextTable
	call	LCD_Out
	movlw	VRCON_Clear		; Clear and set up VREF
	bsf	rp0
	movwf	VRCON
	bcf	rp0
	movlw	VRCON_Clear		; Load counter with setup value for VREF
	movwf	S_Count
	return
	;
;*****************************************************************************
;	PttKey - Toggle between Tx and Rx 
;******************************************************************************
PttKey
	call	ClearScan
	btfss	New_Key_Flag
	goto	PttKeyEnd		; Not a new key press
	bcf	New_Key_Flag
	btfsc	SystemFlag
	goto	SetTxOff
	btfsc	TxOn
	goto	SetTxOff		; Turn Tx off if on
SetTxOn
	bsf	TxOn			; Indicate TxOn
	bcf	S_Flag			; Turn "S" meter off so display visible
	bcf	AutoNetOn		; Default to autonet off
	btfsc	AutoNetEnable
	bsf	AutoNetOn
	call	TxDisplayRoutine	; Diplay Tx frequency
	call	RxRoutine		; If autonet on resets Rx synth and display
	movlw	.3
	movwf	OolCount		; Preset count with 3
	bsf	CoRelay			; Set change over relay to Tx (pin high)
	movlw	.86
	movwf	Counter_50mS
	movlw	.5
	movwf	SequenceCount
	goto	PttKeyEnd
SetTxOff
	bcf	TxOn	
	bcf	AutoNetOn
	bcf	PaPower			; Turn power amplifier off
	call	RxRoutine		; If autonet on resets Rx synth and display
	movlw	.86
	movwf	Counter_50mS
	movlw	.10
	movwf	SequenceCount		; Load sequence counter
PttKeyEnd
	return
	;
;*****************************************************************************
;	ToggleAutoNet - Toggles AutoNetEnable and displays  
;******************************************************************************
ToggleAutoNet
	; Set to line 2
	movlw	b'11000000'
	call	send_cmd
	btfss	AutoNetEnable
	goto	ToggleAutoNet1
	bcf	AutoNetEnable		; Clear flag
	movlw	TextOff - TextTable
	goto	ToggleEnd
ToggleAutoNet1
	bsf	AutoNetEnable		; Set flag
	movlw	TextOn - TextTable	
ToggleEnd
	call	LCD_Out			; Display (On or Off)
	return
	;
;*****************************************************************************
;	ToggleBand - Toggles Band and displays  
;******************************************************************************
ToggleBand
	bsf	InitRequestFlag
	movlw	b'11000000'
	call	send_cmd
	btfss	ThirteenCmFlag
	goto	ToggleBand1
	bcf	ThirteenCmFlag		; Clear flag
	movlw	Text23CM - TextTable
	goto	ToggleEnd
ToggleBand1
	bsf	ThirteenCmFlag		; Set flag
	movlw	Text13CM - TextTable	
	goto	ToggleEnd
	;
;*****************************************************************************
;	ToggleSystem - Toggles receive only and displays  
;******************************************************************************
ToggleSystem
	btfss	SystemFlag
	goto	ToggleSystem1
	bcf	SystemFlag		; Clear flag
	movlw	b'11000000'
	call	send_cmd
	movlw	TextRxandTx - TextTable
	goto	ToggleEnd
ToggleSystem1
	bsf	SystemFlag		; Set flag
	movlw	b'11000000'
	call	send_cmd
	movlw	TextRxOnly - TextTable	
	goto	ToggleEnd
	;
;*****************************************************************************
;	ToggleVFOLink - Toggles VFO link off and on  
;******************************************************************************
ToggleVFOLink
	btfss	VFOLinkFlag
	goto	ToggleVFOLink1
	bcf	VFOLinkFlag		; Clear flag
	movlw	b'11000000'
	call	send_cmd
	movlw	TextOff - TextTable
	goto	ToggleEnd
ToggleVFOLink1
	bsf	VFOLinkFlag		; Set flag
	movfw	RxMemNum		
	movwf	TxMemNum
	call	RecallFrequency
	movlw	b'11000000'
	call	send_cmd
	movlw	TextOn - TextTable	
	goto	ToggleEnd
	;
;*****************************************************************************
;	MenuReset - Reset setup menu to base level, IE normal  
;******************************************************************************
MenuReset
	btfss	New_Key_Flag
	goto	MenuResetEnd		; Not a new key press
	bcf	New_Key_Flag
	clrf	KeyMode	
	bcf	IfSetFlag
	call	RecallSettings		; Recall existing IF offset
	call	RxRoutine
	call	TxRoutine
	btfsc	SystemFlag		
	call	SetupSMeter		; Setup S meter if receive only
MenuResetEnd
	return
	;
;*****************************************************************************
;	AutoNetSet - Save IF settings enter AutoNet setup  
;******************************************************************************
AutoNetSet
	btfss	New_Key_Flag
	goto	AutoNetSetEnd		; Not a new key press
	bcf	New_Key_Flag
	call	SaveSettings		; Save new IF frequency
	bcf	IfSetFlag
AutoNetSet1
	movlw	.2
	movwf	KeyMode	
	; Display "Set AutoNet"
	movlw	Clr_display
	call	send_cmd
	movlw	TextSetAutoNet - TextTable
	call	LCD_Out
	;	Set to line two, first character in
	movlw	b'11000000'
	call	send_cmd
	movlw	TextOn - TextTable
	btfss	AutoNetEnable
	movlw	TextOff - TextTable	
	call	LCD_Out
AutoNetSetEnd
	return
	;
;*****************************************************************************
;	SystemSet - Save AutoNet setting and enter System setup  
;******************************************************************************
SystemSet
	btfss	New_Key_Flag
	goto	SystemSetEnd		; Not a new key press
	bcf	New_Key_Flag
	movlw	.3
	movwf	KeyMode	
	call	SaveSettings		; Save AutoNet setting
	; Display "Set System"
	movlw	Clr_display
	call	send_cmd
	movlw	TextSystemSet - TextTable	
	call	LCD_Out
	;	Set to line two, first character in
	movlw	b'11000000'
	call	send_cmd
	movlw	TextRxOnly - TextTable
	btfss	SystemFlag
	movlw	TextRxandTx - TextTable	
	call	LCD_Out
SystemSetEnd
	return
	;
;*****************************************************************************
;	BandSet - Save System setting and enter Band setup  
;******************************************************************************
BandSet
	btfss	New_Key_Flag
	goto	BandSetEnd		; Not a new key press
	bcf	New_Key_Flag
	call	SaveSettings		; Save System setting
	movlw	.4
	movwf	KeyMode	
	; Display "Set Band"
	movlw	Clr_display
	call	send_cmd
	movlw	TextBandSet - TextTable
	call	LCD_Out
	;	Set to line two, first character in
	movlw	b'11000000'
	call	send_cmd
	movlw	Text13CM - TextTable
	btfss	ThirteenCmFlag
	movlw	Text23CM - TextTable	
	call	LCD_Out
BandSetEnd
	return
	;
;*****************************************************************************
;	VFOLinkSet - Save Band setting and enter linked VFO setup  
;******************************************************************************
VFOLinkSet
	btfss	New_Key_Flag
	goto	MenuSaveSetEnd		; Not a new key press
	bcf	New_Key_Flag
	call	SaveSettings		; Save settings
	movlw	.5
	movwf	KeyMode	
	btfss	InitRequestFlag
	goto	VFOLinkSet1
	bcf	InitRequestFlag
	bcf	gie
	btfss	ThirteenCmFlag
	goto	Band1Initialise
	call	Band2Init
	call	RecallFrequency
	call	RxRoutine
	call	TxRoutine
	call	LoadBand2Limits		; Load frequency limits to ram
VFOLinkSet1
	; Display "Rx / Tx VFO Linked"
	bcf	InitRequestFlag
	movlw	Clr_display
	call	send_cmd
	movlw	TextVFOLinked - TextTable
	call	LCD_Out
	;	Set to line two, first character in
	movlw	b'11000000'
	call	send_cmd
	movlw	TextOn - TextTable
	btfss	VFOLinkFlag
	movlw	TextOff - TextTable	
	call	LCD_Out
VFOLinkSetEnd
	return
Band1Initialise
	call	Band1Init
	call	RecallFrequency
	call	LoadBand1Limits		; Load frequency limits to ram
	goto	VFOLinkSet1
	;
;*****************************************************************************
;	MenuSaveSet - Save Linked VFO setting and exit setup  
;******************************************************************************
MenuSaveSet
	btfss	New_Key_Flag
	goto	MenuSaveSetEnd		; Not a new key press
	bcf	New_Key_Flag
	clrf	KeyMode
	call	SaveSettings		; Save settings
	btfsc	SystemFlag
	call	SetupSMeter
	call	RxRoutine
	call	TxRoutine
MenuSaveSetEnd
	return
	;
;*****************************************************************************
;	Beep set - sets up a short beep for key press indication
;******************************************************************************
Beep_Set
	movlw	.20
	movwf	Beep_Duration		; Set for short beep
	bsf	rp0
	bcf	TRISA,0			; Set beep pin for output
	bcf	rp0
	return
	;
;*****************************************************************************
;	Timer routine - used for all timer functions
;******************************************************************************
Timer_Routine
	bcf	gie
	movlw	Timer500uSValue	
Timer_Load
	addwf	TMR0,f			; Load timer 0
	bcf	t0if
Timer_Service
	; Items placed here serviced every 500uS
	movf	Beep_Duration,f
	btfsc	z
	goto	No_Beep
	btfss	Beep_Pin
	goto	Compl_Beep
	bcf	Beep_Pin	
	goto	No_Beep		
Compl_Beep
	bsf	Beep_Pin	
No_Beep
	decfsz	Counter_5ms,f		; Decrement 5ms counter
	goto	Timer_Parse_End
	;   routines in this section are serviced
	;   every 5 ms
	movlw	.10			; Reload 5ms counter
	movwf	Counter_5ms
	movf	ReIncTimer,f		; Check for 0
	btfss	z
	decf	ReIncTimer,f		; If not zero decrement
	movf	ReDecTimer,f		; Check for 0
	btfss	z
	decf	ReDecTimer,f		; If not zero decrement
	;
	call	KeyService
	movf	Beep_Duration,f		; Test for beep finished, if
	btfsc	z			;  not decrement counter
	goto	Beep_Finished
	decfsz	Beep_Duration,f
	goto	Beep_Finished
	bsf  	rp0
	bsf	TRISA,0			; Set beep pin as input
	bcf	rp0
Beep_Finished
	decfsz	Counter_50mS,f
	goto	Timer_Parse_End
	movlw	.10
	movwf	Counter_50mS
	; Items placed here serviced every 50mS
	btfss	S_Flag
	goto	NotSFlag
	call	S_Routine
NotSFlag
	btfsc	FrqScanFlag
	call	ScanInc			; If scan is set increment frequency
	; Sequencer timing section
	movf	SequenceCount,f
	btfsc	z			
	goto	Not_50mS		; Skip section if count finished
	decf	SequenceCount,f
	movlw	.8
	subwf	SequenceCount,w
	btfsc	z
	bcf	TxPower			; Turn Tx module power off
	movlw	.6
	subwf	SequenceCount,w
	btfss	z
	goto	TxFinished
	bcf	CoRelay			; Turn CoRelay to receive
	clrf	SequenceCount
	goto	Not_50mS		; 
TxFinished
	movlw	.4
	subwf	SequenceCount,w
	btfsc	z
	bsf	TxPower			; Turn power on
	movlw	.2
	subwf	SequenceCount,w
	btfsc	z
	call	TxSynthOut		; Load synthesiser
	movf	SequenceCount,f
	btfsc	z
	bsf	PaPower		
Not_50mS
	decfsz	Counter_1s,f		; Decrement 1 second counter
	goto	Timer_Parse_End
	movlw	.20			; Reload 1 sec counter
	movwf	Counter_1s
	; Routines in this section are serviced
	;  every 1 second
	btfsc	FrqScanFlag		; Don't bother resending synth data or
	goto	Save_Delay_Zero		;  saving in scan mode
	btfsc	VFOScanFlag
	goto	VFOScanSet
	; Re-send I2C to Tx
	call	RxSynthOut
	call	TxSynthOut
	movf	Save_Delay,f		; Test for zero
	btfsc	z
	goto	Save_Delay_Zero
	decfsz	Save_Delay,f		; Test for zero
	goto	Save_Delay_Zero
	call	SaveFrequency
	goto	Save_Delay_Zero
VFOScanSet
	call	VFOScan
Save_Delay_Zero
	movf	Init_Disp_Delay,f	; Test startup delay
	btfsc	z
	goto	Timer_Parse_End
	decfsz	Init_Disp_Delay,f
	goto	Timer_Parse_End
	movlw	Clr_display
	call	send_cmd
	call	RxRoutine
	btfsc	SystemFlag
	call	SetupSMeter
	call	TxRoutine
Timer_Parse_End
	bsf	gie
	return
	;
;*****************************************************************************
;	S routine - generates an "S" meter diplay using the onboard
;	presetable v-ref generator (16 levels) and comparator
;******************************************************************************
S_Routine
	movlw	b'11000010'	; Set comparator module
	movwf	CMCON
	call	Delay_10us
	btfss	c2out		; Is S greater than VREF?
	goto	S_Increase	; Yes, so inc VREF and test again
S_Decrease	
	movfw	S_Count		; No
	call	Write_S_Display
	movlw	" "		; Overwrite last character with a space
	call	send_char
	movfw	S_Count		
	bsf	rp0
	movwf	VRCON		; Load VREF with value stored in S_Count
	bcf	rp0
	andlw	b'00001111'	; Is VREF 0?
	btfsc	z
	goto	S_Routine_End	; Yes, quit as meter already idicates lowest value
	bsf	rp0		; No
	decf	VRCON,f		; Decrement VREF
	movfw	VRCON		; Save VREF in S_Count
	bcf	rp0
	movwf	S_Count
	call	Delay_10us
	btfsc	c2out		; Is S geater than VREF?
	goto	S_Decrease	; No, decrement and try again
	goto	S_Routine_End	; Yes, so quit as correct reading now displayed
S_Increase
	movfw	S_Count
	andlw	b'00001111'
	sublw	b'00001111'
	btfsc	z		; Is VREF = 15
	goto	S_Routine_End	; Yes, meter displaying maximum reading so quit	
	movfw	S_Count		; No
	bsf	rp0		
	movwf	VRCON		; Load VREF with value stored in S_Count
	incf	VRCON,f		; Increment VREF
	movfw	VRCON
	bcf	rp0
	call	Delay_10us	; > 10us delay for comparator to settle
	btfsc	c2out		; Is S > VREF?
	goto	S_Routine_End	; No, maximum value found so quit
	movfw	S_Count		; Yes, recall S_Count for display
	call	Write_S_Display
	movlw	.0		; Overwrite character with a "-" (from
	call	send_char	;  character generator ram)
	bsf	rp0		
	movfw	VRCON
	bcf	rp0
	movwf	S_Count
	goto	S_Increase	; Check next value
S_Routine_End
	movfw	S_Count		; Load VREF with count value ready for next call
	bsf	rp0
	movwf	VRCON
	bcf	rp0
	movlw	b'11000111'	; Set comparator module
	movwf	CMCON
	return
	;
;*****************************************************************************
;	RxRoutine
;	Calculates, formats and outputs data to display and Synthesiser
;******************************************************************************
RxRoutine
	call	RxSynthOut
	btfsc	IfSetFlag		
	goto	RxRoutineIfSet		; Don't display if in IF set mode
	btfsc	AutoNetOn	
	goto	RxRoutine1		; Special display for autonet
	call	RxDisplayRoutine
RxRoutineEnd
	return
RxRoutineIfSet
	call	IfSetDisplay
	goto	RxRoutineEnd
RxRoutine1
	call	AutoNetDisplayRoutine
	goto	RxRoutineEnd
	;
;*****************************************************************************
;	TxRoutine
;	Calculates, formats and outputs data to display and Synthesiser
;******************************************************************************
TxRoutine
	btfsc	SystemFlag
	goto	TxRoutineEnd			
	call	TxSynthOut
	call	TxDisplayRoutine	
TxRoutineEnd
	return
	;
;*****************************************************************************
;	ReInc - Increments frequency, normally increments by one unless time from
;	last increment is small then it will increment by 8 
;*****************************************************************************
ReInc
	call	ReClearScan
	movlw	.1
	subwf	KeyMode,w
	btfsc	z
	goto	ReIncSetIf		; IF frequency set
	movlw	.2
	subwf	KeyMode,w
	btfsc	z
	goto	ToggleAutoNet		; AutoNet setup
	movlw	.3
	subwf	KeyMode,w
	btfsc	z
	goto	ToggleSystem		; Rx Tx setup
	movlw	.4
	subwf	KeyMode,w
	btfsc	z
	goto	ToggleBand		; Band setup
	movlw	.5
	subwf	KeyMode,w
	btfsc	z
	goto	ToggleVFOLink		; Linked VFO setup
	; Check speed of rotary encoder
	bcf	c
	rlf	ReIncTimer,f		; *2
	rlf	ReIncTimer,f		; *4
;	rlf	ReIncTimer,f		; *8
;	rlf	ReIncTimer,f		; *16
	movlw	.1
	addwf	ReIncTimer,w
	btfss	RxTxFlag		; Check for Rx or Tx mode
	goto	TxReInc
	btfsc	AutoNetOn
	goto	ReIncEnd		; Not applicable in autonet mode
	addwf	RxFrqLo,f
	btfsc	carry
	incf	RxFrqHi,f
	movfw	RxMaxLmtLo
	subwf	RxFrqLo,w
	movfw	RxMaxLmtHi
	btfss	carry
	addlw	.1
	subwf	RxFrqHi,w
	btfss	carry
	goto	RxIncrement_OK
	movfw	RxMinLmtLo
	movwf	RxFrqLo
	movfw	RxMinLmtHi
	movwf	RxFrqHi
RxIncrement_OK
	movlw	.6			; Set key timer to 8 * 5 ms
	movwf	ReIncTimer
 	movlw	.3			; Forces a data save in Eeprom
 	movwf	Save_Delay		;  of memory data after 3 seconds
	call	RxRoutine		; Forces recall of memory to synth etc
ReIncEnd
	return
ReIncSetIf
	movlw	.1
	addwf	IfOfstLo,f
	btfsc	carry
	incf	IfOfstHi,f		; Add carry
	movlw	LOW IfFreqMax		; Test for limit reached
	subwf	IfOfstLo,w
	movlw	HIGH IfFreqMax
	btfss	carry
	addlw	.1
	subwf	IfOfstHi,w
	btfss	carry
	goto	ReIncSetIfOK
	movlw	LOW IfFreqMax
	movwf	IfOfstLo
	movlw	HIGH IfFreqMax
	movwf	IfOfstHi
ReIncSetIfOK
	call	IfSetDisplay
	call	RxRoutine
	goto	ReIncEnd
	;
TxReInc
	addwf	TxFrqLo,f
	btfsc	carry
	incf	TxFrqHi,f
	movfw	TxMaxLmtLo
	subwf	TxFrqLo,w
	movfw	TxMaxLmtHi
	btfss	carry
	addlw	.1
	subwf	TxFrqHi,w
	btfss	carry
	goto	TxIncrement_OK
	movfw	TxMinLmtLo
	movwf	TxFrqLo
	movfw	TxMinLmtHi
	movwf	TxFrqHi
TxIncrement_OK
	movlw	.6			; Set key timer to 5 * 5 ms
	movwf	ReIncTimer
 	movlw	.3			; Forces a data save in Eeprom
 	movwf	Save_Delay		;  of memory data after 3 seconds
	call	TxRoutine		; Forces recall of memory to synth etc
	btfsc	AutoNetOn
	call	RxRoutine		; re display Rx only if Autonet in operation
	return
	;
;*****************************************************************************
;	ReDec - Decrements frequency, normally decrements by one unless time from last 
;	decrement is small then it will decrement by 8
;*****************************************************************************
ReDec	
	call	ReClearScan
	movlw	.1
	subwf	KeyMode,w
	btfsc	z
	goto	ReDecSetIf		; IF frequency set
	movlw	.2
	subwf	KeyMode,w
	btfsc	z
	goto	ToggleAutoNet		; AtoNet setup
	movlw	.3
	subwf	KeyMode,w
	btfsc	z
	goto	ToggleSystem		; AtoNet setup
	movlw	.4
	subwf	KeyMode,w
	btfsc	z
	goto	ToggleBand		; AtoNet setup
	movlw	.5
	subwf	KeyMode,w
	btfsc	z
	goto	ToggleVFOLink		; Linked VFO setup
	; Check speed of rotary encoder
	bcf	c
	rlf	ReDecTimer,f		; *2
	rlf	ReDecTimer,f		; *4
;	rlf	ReDecTimer,f		; *8
;	rlf	ReDecTimer,f		; *16
	movlw	.1
	addwf	ReDecTimer,w
	btfss	RxTxFlag
	goto	TxReDec
	btfsc	AutoNetOn
	goto	ReDecEnd		; Not applicable in autonet mode
	subwf	RxFrqLo,f
	btfss	carry
	decf	RxFrqHi,f
	movfw	RxMinLmtLo
	subwf	RxFrqLo,w
	movfw	RxMinLmtHi
	btfss	carry
	addlw	.1
	subwf	RxFrqHi,w
	btfsc	carry
	goto	Rxdecrement_OK
	movfw	RxMaxLmtLo
	movwf	RxFrqLo
	movfw	RxMaxLmtHi
	movwf	RxFrqHi	
Rxdecrement_OK
	movlw	.6			; Set key timer to 5 * 5 ms
	movwf	ReDecTimer
	movlw	.3			; Forces a data save in Eeprom
 	movwf	Save_Delay		; of memory data after 3 seconds
	call	RxRoutine		; Forces recall of memory to synth etc
ReDecEnd
	return
ReDecSetIf
	movlw	.1
	subwf	IfOfstLo,f
	btfss	carry
	decf	IfOfstHi,f		; Add carry
	movlw	LOW IfFreqMin
	subwf	IfOfstLo,w
	movlw	HIGH IfFreqMin
	btfss	carry
	addlw	.1
	subwf	IfOfstHi,w
	btfsc	carry
	goto	ReDecSetIfOK
	movlw	LOW IfFreqMin
	movwf	IfOfstLo
	movlw	HIGH IfFreqMin
	movwf	IfOfstHi
ReDecSetIfOK
	call	IfSetDisplay
	call	RxRoutine
	goto	ReDecEnd
	;
TxReDec
	subwf	TxFrqLo,f
	btfss	carry
	decf	TxFrqHi,f
	movfw	TxMinLmtLo
	subwf	TxFrqLo,w
	movfw	TxMinLmtHi
	btfss	carry
	addlw	.1
	subwf	TxFrqHi,w
	btfsc	carry
	goto	Txdecrement_OK
	movfw	TxMaxLmtLo
	movwf	TxFrqLo
	movfw	TxMaxLmtHi
	movwf	TxFrqHi
Txdecrement_OK
	movlw	.6			; Set key timer to 5 * 5 ms
	movwf	ReDecTimer
	movlw	.3			; Forces a data save in Eeprom
 	movwf	Save_Delay		; of memory data after 3 seconds
	call	TxRoutine		; Forces recall of memory to synth etc
	btfsc	AutoNetOn
	call	RxRoutine		; re display Rx only if Autonet in operation
	return
	;
;*****************************************************************************
;	Saves frequency in Eeprom
;*****************************************************************************
SaveFrequency
	;	Save receive memory
	bcf	carry	
	rlf	RxMemNum,w		; Memory number * 2
	addlw	RxMemBaseAddr		; Add base address offset
	movwf	Temp			; Save for later
	bsf	rp0
	movwf	EEADR
	bcf	rp0
	movfw	RxFrqLo
	bsf	rp0
	movwf	EEDATA
	call	WriteEeprom
	incf	Temp,w
	bsf	rp0
	movwf	EEADR
	bcf	rp0
	movfw	RxFrqHi
	bsf	rp0
	movwf	EEDATA
	call	WriteEeprom
	;	Save transmit memory
	bcf	carry	
	rlf	TxMemNum,w		; Memory number * 2
	addlw	TxMemBaseAddr		; Add base address offset
	movwf	Temp			; Save for later
	bsf	rp0
	movwf	EEADR
	bcf	rp0
	movfw	TxFrqLo
	bsf	rp0
	movwf	EEDATA
	call	WriteEeprom
	incf	Temp,w
	bsf	rp0
	movwf	EEADR
	bcf	rp0
	movfw	TxFrqHi
	bsf	rp0
	movwf	EEDATA
	call	WriteEeprom
	return
;
;*****************************************************************************
;	Recalls frequency from Eeprom
;*****************************************************************************
RecallFrequency
	;	Recall receive memory
	bcf	carry	
	rlf	RxMemNum,w		; Memory number * 2
	addlw	RxMemBaseAddr		; Add base address offset
	movwf	Temp			; Save for later
	call	FetchEedata
	movwf	RxFrqLo
	;
	incf	Temp,w
	call	FetchEedata
	movwf	RxFrqHi
	;	Recall transmit memory
	bcf	carry	
	rlf	TxMemNum,w		; Memory number * 2
	addlw	TxMemBaseAddr		; Add base address offset
	movwf	Temp			; Save for later
	call	FetchEedata
	movwf	TxFrqLo
	;
	incf	Temp,w
	call	FetchEedata
	movwf	TxFrqHi
	return
;
FetchEedata
	bsf	rp0
	movwf	EEADR
	bsf	rd
	movfw	EEDATA
	bcf	rp0
	return
	;
;*****************************************************************************
;	Recalls frequency from Eeprom
;*****************************************************************************
RecallSettings
	; Recall settings from Eeprom
	movlw	Flags1		; Load indirection register with location of Flags1
	movwf	FSR
	movlw	.5		; Number of registers to recall
	movwf	Count
	clrf	Temp		; Location in Eeprom	
RegisterLoadLoop
	movfw	Temp
	call	FetchEedata
	movwf	INDF		; Load regsiter pointed to by FSR
	incf	FSR,f
	incf	Temp,f
	decfsz	Count,f
	goto	RegisterLoadLoop
	return
	;
;*****************************************************************************
;	Saves registers to Eeprom
;*****************************************************************************
SaveSettings
	movlw	Flags1		; Load indirection register with location of Flags1
	movwf	FSR
	movlw	.5		; Number of registers to save
	movwf	Bit_Count
	clrf	Temp		; Location in Eeprom	
RegisterSaveLoop
	movfw	Temp
	bsf	rp0
	movwf	EEADR
	bcf	rp0
	movfw	INDF		; Load regsiter pointed to by FSR
	bsf	rp0		;  into EEDATA
	movwf	EEDATA
	call	WriteEeprom
	incf	FSR,f
	incf	Temp,f
	decfsz	Bit_Count,f
	goto	RegisterSaveLoop
	return
;
;*****************************************************************************
;	Write Eeprom - Write to Eeprom routine
;*****************************************************************************
;
Stop_here
	goto Stop_here
	goto Stop_here
;
WriteEeprom
	bcf	rp0
	bcf	PIR1,EEIF
	bsf	rp0
	bsf	wren
	movlw  	h'55'                  	;write "keys" to eerom
	movwf  	EECON2               	;registers to open eerom
	movlw  	h'AA'                 	;for writing
	movwf  	EECON2
	bsf    	wr
	bcf	rp0
Write_Loop    
	clrwdt                      	; Watchdog cleared otherwise
	btfss	PIR1,EEIF		;  it is likely to reset due to 
	goto	Write_Loop    		;  write delay
	bsf	rp0
	bcf	wren
	bcf	rp0
	return
	;			
;*****************************************************************************
;	Initialise new Eeprom with starting values
;*****************************************************************************
EEPROMInit
	; Load Values from IniTable into Eeprom 
	movlw	HIGH InitTable
	movwf	PCLATH
	movlw	InitTableEnd - InitTable 	; Set end pointer
	movwf	Count
	clrf	Temp
EepromInitLoop1
	movfw	Temp
	call	InitTable			; Looks up value and returns in W
	call	WriteEedata	
	incf	Temp,f
	decfsz	Count,f
	goto	EepromInitLoop1
Band1Init
	; Write receive memories with default frequency
	movlw	MaxMem + 1
	movwf	Count
	movlw	RxMemBaseAddr
	movwf	Temp
EepromInitLoop2
	movlw	LOW Band1DefaultFreq
	call	WriteEedata	
	incf	Temp,f
	movlw	HIGH Band1DefaultFreq
	call	WriteEedata	
	incf	Temp,f
	decfsz	Count,f
	goto	EepromInitLoop2
	; Write transmit memories with default frequency
	movlw	MaxMem + 1
	movwf	Count
	movlw	TxMemBaseAddr
	movwf	Temp
EepromInitLoop3
	movlw	LOW Band1DefaultFreq
	call	WriteEedata	
	incf	Temp,f
	movlw	HIGH Band1DefaultFreq
	call	WriteEedata	
	incf	Temp,f
	decfsz	Count,f
	goto	EepromInitLoop3
	; Save version number
	movlw	VersionNumber
	bsf	rp0
	movwf	EEDATA
	movlw	VersionNumberAddr
	movwf	EEADR
	call	WriteEeprom
	Return				; Finished
	;
InitTable
	addwf	PCL,f
	retlw	b'00000001'	; Flags1, Rx mode set
	retlw	0		; Rx memory number
	retlw	0		; Tx memory number
	retlw	LOW IFOffset	; Default IF Offset
InitTableEnd
	retlw	HIGH IFOffset
	;
	if HIGH InitTable != HIGH InitTableEnd 
	error "Table breaks page boundary"
	endif
	;
WriteEedata
	bsf	rp0
	movwf	EEDATA
	bcf	rp0
	movfw	Temp
	bsf	rp0
	movwf	EEADR
	call	WriteEeprom
	return
	;
Band2Init
	; Write receive memories with default frequency
	movlw	MaxMem + 1
	movwf	Count
	movlw	RxMemBaseAddr
	movwf	Temp
Band2EEPROMInit2
	movlw	LOW Band2DefaultFreq
	call	WriteEedata	
	incf	Temp,f
	movlw	HIGH Band2DefaultFreq
	call	WriteEedata	
	incf	Temp,f
	decfsz	Count,f
	goto	Band2EEPROMInit2
	; Write transmit memories with default frequency
	movlw	MaxMem + 1
	movwf	Count
	movlw	TxMemBaseAddr
	movwf	Temp
Band2EEPROMInit3
	movlw	LOW Band2DefaultFreq
	call	WriteEedata	
	incf	Temp,f
	movlw	HIGH Band2DefaultFreq
	call	WriteEedata	
	incf	Temp,f
	decfsz	Count,f
	goto	Band2EEPROMInit3
	return
	;
;*****************************************************************************
;	Displays IF offset
;*****************************************************************************
IfSetDisplay
	;	Clear display and set at begining
	movlw	Clr_display
	call	send_cmd
	movlw	Text_SetIfOffset - TextTable
	call	LCD_Out
	;	Set to line two, fourth character in
	movlw	b'11000011'
	call	send_cmd
	;
	movfw	IfOfstLo
	movwf	ACC_a_0
	movfw	IfOfstHi
	movwf	ACC_a_1
	movlw	LOW .125	; Multiply freq by ref
	movwf	ACC_b_0
	movlw	HIGH .125
	movwf	ACC_b_1
	call	D_mpy
	movfw	ACC_b_0		; 32 bit result is in ACC_b_1, ACC_b_0
	movwf	ACC_b_2		;  ACC_c_1, ACC_c_0 
	movfw	ACC_c_1
	movwf	ACC_b_1
	movfw	ACC_c_0
	movwf	ACC_b_0
	call	B2_BCD	
	call	Expand_BCD
	;
	movfw	Buffer_1
	call	send_char	; 100MHz
	movfw	Buffer_2
	call	send_char	; 10MHz
	movfw	Buffer_3
	call	send_char	; 1MHz
	movlw	"."	
	call	send_char	; Display "."
	movfw	Buffer_4
	call	send_char	; 100KHz
	movfw	Buffer_5
	call	send_char	; 10KHz
	movfw	Buffer_6
	call	send_char	; 1KHz
	;
	movlw	Text_MHz - TextTable
	call	LCD_Out
	return

;*****************************************************************************
;	Sends Tx data to display
;*****************************************************************************
TxDisplayRoutine
	btfsc	S_Flag
	goto	RxDisplayRoutineEnd
	movlw	b'11001111'
	call	send_cmd
	movlw	">"		; Display ">" in last character on line
	btfsc	RxTxFlag
	movlw	" "		; Display " " in last character on line
	call	send_char
	;	Reset display to line 2 character 1
	movlw	Line_Two
	call	send_cmd
	movlw	"M"		
	call	send_char	; Display "M"
	clrf	ACC_b_2		 
	clrf	ACC_b_1
	movfw	TxMemNum
	movwf	ACC_b_0
	call	B2_BCD	
	call	Expand_BCD
	movfw	Buffer_6
	call	send_char	; Display memory number
	movlw	" "
	call	send_char	; Display space	
	;	Output Frequency
	movfw	TxFrqLo
	movwf	ACC_a_0
	movfw	TxFrqHi
	movwf	ACC_a_1
	goto	FreqDisp
;*****************************************************************************
;	Sends Rx data to display
;*****************************************************************************
RxDisplayRoutine
	movlw	b'10001111'
	call	send_cmd
	btfsc	SystemFlag	
	goto	RxDisplayRoutine1	; Display " " in Rx only mode
	movlw	">"		; Display ">" in last character on line
	btfss	RxTxFlag
RxDisplayRoutine1
	movlw	" "		; Display " " in last character on line
	call	send_char
	;	Reset display to line 1 character 1
	movlw	Line_One
	call	send_cmd
	movfw	RxMemNum
	sublw	MaxMem - 1	; Check for scan low limit
	btfss	z
	goto	NotScanLo
	movlw	"S"		
	call	send_char	; Display "M"
	movlw	"L"		
	call	send_char	; Display "M"
	goto	SendSpace
NotScanLo
	movfw	RxMemNum
	sublw	MaxMem 		; Check for scan high limit
	btfss	z
	goto	DisplayMemNum
	movlw	"S"		
	call	send_char	; Display "M"
	movlw	"U"		
	call	send_char	; Display "M"
	goto	SendSpace
DisplayMemNum
	movlw	"M"		
	call	send_char	; Display "M"
	clrf	ACC_b_2		 
	clrf	ACC_b_1
	movfw	RxMemNum
	movwf	ACC_b_0
	call	B2_BCD	
	call	Expand_BCD
	movfw	Buffer_6
	call	send_char	; Display memory number
SendSpace
	movlw	" "
	call	send_char	; Display space	
	;	Output Frequency
	movfw	RxFrqLo
	movwf	ACC_a_0
	movfw	RxFrqHi
	movwf	ACC_a_1
FreqDisp
	movlw	LOW .125	; Multiply freq by ref
	movwf	ACC_b_0
	movlw	HIGH .125
	movwf	ACC_b_1
	call	D_mpy
	movfw	ACC_b_0		; 32 bit result is in ACC_b_1, ACC_b_0
	movwf	ACC_b_2		;  ACC_c_1, ACC_c_0 
	movfw	ACC_c_1
	movwf	ACC_b_1
	movfw	ACC_c_0
	movwf	ACC_b_0
	call	B2_BCD	
	call	Expand_BCD
;
	movfw	Buffer_0	
	call	send_char	; 1000MHz
	movfw	Buffer_1
	call	send_char	; 100MHz
	movfw	Buffer_2
	call	send_char	; 10MHz
	movfw	Buffer_3
	call	send_char	; 1MHz
	movlw	"."	
	call	send_char	; Display "."
	movfw	Buffer_4
	call	send_char	; 100KHz
	movfw	Buffer_5
	call	send_char	; 10KHz
	movfw	Buffer_6
	call	send_char	; 1KHz
	movlw	Text_MHz - TextTable
	call	LCD_Out
RxDisplayRoutineEnd
	return
;*****************************************************************************
;	Sends Rx data to display in Autonet mode
;*****************************************************************************
AutoNetDisplayRoutine
	movlw	b'10001111'
	call	send_cmd
	movlw	" "		; Display " " in last character on line
	call	send_char
	; Set to display on line one
	movlw	Line_One
	call	send_cmd
	movlw	"A"		
	call	send_char	; Display "A"
	movlw	"N"		
	call	send_char	; Display "N"
	movlw	" "
	call	send_char	; Display space	
	;	Output Frequency
	movfw	TxFrqLo
	movwf	ACC_a_0
	movfw	TxFrqHi
	movwf	ACC_a_1
	goto	FreqDisp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
Expand_BCD
	movfw	R0
	addlw	h'30'		; Add ascii offset
	movwf	Buffer_0
;
	swapf	R1,w
	andlw	h'0f'		; Mask off lower nibble
	addlw	h'30'
	movwf	Buffer_1
;
	movfw	R1
	andlw	h'0f'		; Mask off lower nibble	
	addlw	h'30'
	movwf	Buffer_2
;
	swapf	R2,w
	andlw	h'0f'		; Mask off lower nibble
	addlw	h'30'
	movwf	Buffer_3
;
	movfw	R2
	andlw	h'0f'		; Mask off lower nibble	
	addlw	h'30'
	movwf	Buffer_4
;
	swapf	R3,w
	andlw	h'0f'		; Mask off lower nibble
	addlw	h'30'
	movwf	Buffer_5
;
	movfw	R3
	andlw	h'0f'		; Mask off lower nibble	
	addlw	h'30'
	movwf	Buffer_6
	return

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	Rx Synthesiser routine
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
RxSynthOut
	movfw	IfOfstLo		; Add IF offset (Osc high)
	btfsc	AutoNetOn
	goto	RxSynthOut1		; In autonet mode
	; Use Tx data if Net Rx to Tx flag set
	btfsc	ThirteenCmFlag		; Skip if 13cm
	goto	OscLoRx	
	addwf	RxFrqLo,w		; Add offset on 23cm
	movwf	Synth_LO
	movfw	IfOfstHi
	btfsc	carry
	addlw	.1
	addwf	RxFrqHi,w
	goto	RxSynthOut2
OscLoRx
	subwf	RxFrqLo,w
	movwf	Synth_LO
	movfw	IfOfstHi
	btfss	carry
	addlw	.1
	subwf	RxFrqHi,w
	goto	RxSynthOut2
RxSynthOut1
	btfss	ThirteenCmFlag		; Skip if 13cm
	goto	OscHi
OscLow
	subwf	TxFrqLo,w
	movwf	Synth_LO
	movfw	IfOfstHi
	btfss	carry
	addlw	.1
	subwf	TxFrqHi,w
	goto	RxSynthOut2
OscHi
	addwf	TxFrqLo,w		; Add IF offset (Osc high)
	movwf	Synth_LO
	movfw	IfOfstHi
	btfsc	carry
	addlw	.1
	addwf	TxFrqHi,w
RxSynthOut2
	movwf	Synth_HI
	call   	RxI2cStart
	movlw	RxI2cAddr
	movwf	I2cData
	call   	RxI2cTx
	movfw  	Synth_HI 		;synth high
	movwf	I2cData
	call   	RxI2cTx
	movfw  	Synth_LO 		;synth low
	movwf	I2cData
	call   	RxI2cTx
	movlw	Synth_Control_1
	movwf	I2cData
	call   	RxI2cTx
	movlw  	Synth_Control_2
	movwf	I2cData
	call   	RxI2cTx
	call   	RxI2cStop
	return
	
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	Tx Synthesiser routine
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
TxSynthOut
	movf	TxFrqLo,w
	movwf	Synth_LO
	movf	TxFrqHi,w
	movwf	Synth_HI
	call   	TxI2cStart
	movlw	TxI2cAddr
	movwf	I2cData
	call   	TxI2cTx
 	movfw  	Synth_HI 		;synth high
	movwf	I2cData
	call   	TxI2cTx
	movfw  	Synth_LO 		;synth low
	movwf	I2cData
	call   	TxI2cTx
	movlw	Synth_Control_1
	movwf	I2cData
	call   	TxI2cTx
	movlw  	Synth_Control_2
	movwf	I2cData
	call   	TxI2cTx
	call   	TxI2cStop
	return
	
;******************************************************************************
;	Read_Status_Byte - Reads Tx I2C status byte and returns with carry set
;	if synthesiser in lock
;******************************************************************************
Read_Status_Byte
	call   	TxI2cStart
	movlw  	TxI2cAddr          	; ic address 
	iorlw	b'00000001'		; Set read bit
	movwf	I2cData
	call   	TxI2cTx
	call	TxI2cRx
	call   	TxI2cStop
	return
	;
;******************************************************************************
;	Receive	I2C Routines
;******************************************************************************

RxI2cStart     
	; I2C start, sent at start of new comunication
	ClrRxSda       	
	call	I2C_Delay
	ClrScl			;set start condition
	return

RxI2cTx        
	; I2C transmit, data to be transmitted is in I2cData
	movlw  	.8              ;loop 8 times (8 bits)
	movwf  	Count
RxI2cTxLoop    
	rlf    	I2cData,f     	;rotate into c
	btfsc  	c
	goto	RxSetRxSda
	ClrRxSda
	goto	RxContinue
RxSetRxSda
	SetRxSda
RxContinue
	call	I2C_Delay
	SetScl       		;clock data bit 
	call	I2C_Delay
	ClrScl      		;out
	decfsz 	Count,1
	goto   	RxI2cTxLoop
	SetRxSda        	;input to allow for
	SetScl     		;aknowledge
	bsf	c
	call	I2C_Delay
	btfss	PORTB,RxSda
	bcf	c		;clear c if aknowledge
	ClrScl
       	return
;RxI2cRx
;	; I2C receive, data returned in I2cData
;	movlw  	.8              ;loop 8 times (8 bits)
;	movwf  	Count
;RxI2cRxLoop    
;	SetScl
;	bsf  	c
;	call	I2C_Delay
;	btfss  	PORTA,RxSda
;	bcf    	c
;	call	I2C_Delay
;	ClrScl      	
;	rlf    	I2cData,f      	;rotate c into I2cData
;	decfsz 	Count,1
;	goto   	RxI2cRxLoop
;	return

RxI2CAknow
	; aknowledge bit, used to aknowlede byte of data correctly received
	ClrRxSda		; aknowledge bit
	call	I2C_Delay
	SetScl     		; clock
	call	I2C_Delay
	ClrScl			; out
	return

RxI2cStop      
	; stop bit, used to halt I2C comunication and frees bus
	ClrRxSda
	call	I2C_Delay
	SetScl
	call	I2C_Delay
	SetRxSda
	return

I2C_Delay
	nop
	return
	
;******************************************************************************
;	Transmit I2C Routines
;******************************************************************************

TxI2cStart     
	; I2C start, sent at start of new comunication
	ClrTxSda       	
	call	I2C_Delay
	ClrScl			;set start condition
	return

TxI2cTx        
	; I2C transmit, data to be transmitted is in I2cData
	movlw  	.8              ;loop 8 times (8 bits)
	movwf  	Count
TxI2cTxLoop    
	rlf    	I2cData,f     	;rotate into c
	btfsc  	c
	goto	TxSetTxSda
	ClrTxSda
	goto	TxContinue
TxSetTxSda
	SetTxSda
TxContinue
	call	I2C_Delay
	SetScl       		;clock data bit 
	call	I2C_Delay
	ClrScl      		;out
	decfsz 	Count,1
	goto   	TxI2cTxLoop
	SetTxSda        	;input to allow for
	SetScl     		;aknowledge
	bsf	c
	call	I2C_Delay
	btfss	PORTB,TxSda
	bcf	c		;clear c if aknowledge
	ClrScl
       	return
TxI2cRx
	; I2C receive, data returned in I2cData
	movlw  	.8              ;loop 8 times (8 bits)
	movwf  	Count
TxI2cRxLoop    
	SetScl
	bsf  	c
	call	I2C_Delay
	btfss  	PORTA,TxSda
	bcf    	c
	call	I2C_Delay
	ClrScl      	
	rlf    	I2cData,f      	;rotate c into I2cData
	decfsz 	Count,1
	goto   	TxI2cRxLoop
	return

TxI2CAknow
	; aknowledge bit, used to aknowlede byte of data correctly received
	ClrTxSda		; aknowledge bit
	call	I2C_Delay
	SetScl     		; clock
	call	I2C_Delay
	ClrScl			; out
	return

TxI2cStop      
	; stop bit, used to halt I2C comunication and frees bus
	ClrTxSda
	call	I2C_Delay
	SetScl
	call	I2C_Delay
	SetTxSda
	return
	
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;		Modified from AN526
;********************************************************************
;                  Binary To BCD Conversion Routine
;      This routine converts a 24 Bit binary Number to a 7 Digit
; BCD Number. 
;       The 24 bit binary number is input in locations ACC_b_2,ACC_b_1 and
; ACC_b_0 with the high byte in ACC_b_2.
;       The 7 digit BCD number is returned in R0, R1, R2 and R3 with R0
; containing the MSD in its right most nibble.
;
;
;       Program:          B16TOBCD.ASM 
;
;*******************************************************************;
;
B2_BCD  bcf     STATUS,0 	; clear the carry bit
	movlw   .24
	movwf   Count
	clrf    R0
	clrf    R1
	clrf    R2
	clrf	R3
loop24  
	rlf     ACC_b_0, F
	rlf     ACC_b_1, F
	rlf     ACC_b_2, F
	rlf     R3, F
	rlf     R2, F
	rlf     R1, F
	rlf     R0, F
;
	decfsz  Count, F
	goto    adjDEC
	RETLW   0
;
adjDEC  
	movlw   R3
	movwf   FSR
	call    adjBCD
;
	movlw   R2
	movwf   FSR
	call    adjBCD
;
	movlw   R1
	movwf   FSR
	call    adjBCD
;
	movlw   R0
	movwf   FSR
	call    adjBCD
;
	goto    loop24
;
adjBCD  movlw   3
	addwf   0,W
	movwf   Temp_1
	btfsc   Temp_1,3	; test if result > 7
	movwf   0
	movlw   30
	addwf   0,W
	movwf   Temp_1
	btfsc   Temp_1,7 	; test if result > 7
	movwf   0              	; save as MSD
	retlw   0
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;		Modified from AN526
;************************************************************************
;               BCD To Binary Conversion
;
;       This routine converts a 7 digit BCD number to a 24 bit binary
; number.
;       The input 7 digit BCD numbers are asumed to be in locations
; R0, R1, R2 & R3 with R0 containing the MSD in its right most nibble.
;
;       The 24 bit binary number is output in registers ACC_b_2, ACC_b_1 & ACC_b_0
; ( high byte & low byte repectively ).
;
;       The method used for conversion is :
;               input number X = abcde ( the 5 digit BCD number )
;               X = abcde = 10[10[10[10a+b]+c]+d]+e
;
;*******************************************************************;
;

;mpy10b  andlw   0F
;	addwf   ACC_b_0, F
;	movlw	.1
;	btfsc   carry
;	addwf   ACC_b_1, F
;	btfsc	carry
;	addwf	ACC_b_2, F
;mpy10a  bcf     carry    	; multiply by 2
;	rlf     ACC_b_0,w
;	movwf   ACC_c_0
;	rlf     ACC_b_1,w        
;	movwf   ACC_c_1
;	rlf     ACC_b_2,w	; (ACC_b_2,ACC_b_1,ACC_b_0) = 2*N
;	movwf   ACC_c_2
;
;	bcf     carry		; multiply by 2
;	rlf     ACC_b_0, F
;	rlf     ACC_b_1, F
;	rlf     ACC_b_2, F
;	bcf     carry 		; multiply by 2
;	rlf     ACC_b_0, F
;	rlf     ACC_b_1, F
;	rlf     ACC_b_2, F
;	bcf     carry 		; multiply by 2
;	rlf     ACC_b_0, F
;	rlf     ACC_b_1, F
;	rlf     ACC_b_2, F	; (ACC_a_2,ACC_a_1,ACC_a_0) = 8*N
;
;	movf    ACC_c_0,w
;	addwf   ACC_b_0, F
;	btfss   carry
;	goto	No_Carry_1
;	movlw	.1
;	addwf	ACC_b_1, F
;	btfsc	carry
;	incf	ACC_b_2, f
;No_Carry_1
;	movf    ACC_c_1,w
;	addwf   ACC_b_1, F
;	btfsc	carry
;	incf	ACC_b_2, f
;	movf    ACC_c_2,w
;	addwf   ACC_b_2, F
;	retlw   0               ; (ACC_b_2,ACC_a_1,ACC_a_0) = 10*N
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;		Modified from AN526
;*******************************************************************
;                    Double Precision Multiplication
;
;               ( Optimized for Code Size : Looped Code )
;
;*******************************************************************;
;   Multiplication : ACCb(16 bits) * ACCa(16 bits) -> ACCb,ACCc ( 32 bits )
;      (a) Load the 1st operand in location ACC_a_0 & ACC_a_1 ( 16 bits )
;      (b) Load the 2nd operand in location ACC_b_0 & ACC_b_1 ( 16 bits )
;      (c) CALL D_mpy
;      (d) The 32 bit result is in location ( ACC_b_1,ACC_b_0,ACC_c_1,ACC_c_0 )
;
;   Performance :
;               Program Memory  :       033
;               Clock Cycles    :       333
;
;       Note : The above timing is the worst case timing, when the
;               register ACCb = FFFF. The speed may be improved if
;               the register ACCb contains a number ( out of the two
;               numbers ) with less number of 1s.
;               The performance specs are for Unsigned arithmetic ( i.e,
;               with "SIGNED equ  FALSE ").
;
;               The performance specs are for Unsigned arithmetic ( i.e,
;               with "SIGNED equ  FALSE ").
;
;
;       Program:          DBL_MPYS.ASM 
;       Revision Date:   
;                         12-12-95      Compatibility with MPASMWIN 1.30
;
;*******************************************************************;
;         Double Precision Addition ( ACCb + ACCa -> ACCb )
;
D_add   bcf	mult_carry	;Clear Temp_1 Carry bit
	movf    ACC_a_0,w        ; Addition ( ACCb + ACCa -> ACCb )
	addwf   ACC_b_0, F       ;add lsb
	movlw	.1
	btfsc   carry		;add in carry
 	addwf	ACC_b_1, F
	btfsc	carry
	bsf	mult_carry	
	movf    ACC_a_1,w
	addwf   ACC_b_1, F         ;add msb
	btfsc	mult_carry
	bsf	carry
	retlw   0
;*******************************************************************
;               Double Precision Multiply ( 16x16 -> 32 )
;         ( ACCb*ACCa -> ACCb,ACCc ) : 32 bit output with high word
;  in ACCb ( ACC_b_1,ACC_b_0 ) and low word in ACCc ( ACC_c_1,ACC_c_0 ).
;
D_mpy                           ;results in ACCb(16 msb's) and ACCc(16 lsb's)
;
	call    setup
mloop   rrf     ACC_d_1, F       ;rotate d right
	rrf     ACC_d_0, F
	btfsc   carry    	;need to add?
	call    D_add
	rrf     ACC_b_1, F
	rrf     ACC_b_0, F
	rrf     ACC_c_1, F
	rrf     ACC_c_0, F
	decfsz  Temp_1, F         ;loop until all bits checked
	goto    mloop
;
	retlw   0
;*******************************************************************
;
setup   movlw   .16             ; for 16 shifts
	movwf   Temp_1
	movf    ACC_b_1,w          ;move ACCb to ACCd
	movwf   ACC_d_1
	movf    ACC_b_0,w
	movwf   ACC_d_0
	clrf    ACC_b_1
	clrf    ACC_b_0
	retlw   0
;
;*******************************************************************
;
neg_A   comf    ACC_a_0, F       ; negate ACCa ( -ACCa -> ACCa )
	incf    ACC_a_0, F
	btfsc   z
	decf    ACC_a_1, F
	comf    ACC_a_1, F
	retlw   0
;
;*****************************************************************************
;	Delay routines used elsewhere                                  
;	                                                      
;******************************************************************************
Delay_10us
	movlw	.10
	movwf	Temp
Delay_Loop
	decfsz	Temp,f
	goto	Delay_Loop
	return

;Delay_1ms
;	movlw	.255
;	movwf	Temp
;Delay_Loop1
;	nop
;	nop
;	nop
;	decfsz	Temp,f
;	goto	Delay_Loop1
;	return
	
;*****************************************************************************
;	Write to "S" meter                    
;	                                                      
;******************************************************************************
Write_S_Display
	andlw	b'00001111'	; Mask S_Count to obtain cursor position
	addlw	.1		; Add offset generated by the "S"
	iorlw	b'10000000'	; Bit 7 set for command "move to"
	iorlw	b'01000000'	; Use second line for two line display
	call	send_cmd
	return

;*****************************************************************************
LCD_Out 
LCD_Out_loop
	movwf	Text_pointer
	movwf   Temp_1           	;Temp_1 holds start of message 
	movlw	LOW TextTable	;address
	addwf	Temp_1,f		;add offset
	movlw	HIGH TextTable	
	btfsc	c			;check if over page boundary
	addlw	1			;yes so inc high byte
	movwf	PCLATH
	movfw	Temp_1
	call	TextTable
	andlw   0ffh   			;check if at end of message (zero
	btfsc   z	  		;returned at end)
	goto    LCD_Out_end         
	call    send_char		;display character
	movfw   Text_pointer		;point to next character
	addlw   1
	goto    LCD_Out_loop
LCD_Out_end
	return
;******************************************************************************
	
	include lcd_4bit.inc

	end
